var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export function getDevice(arg) {
    return __awaiter(this, void 0, void 0, function* () {
        const { deep, deviceLinkId } = arg;
        //   const nameTypeLinkId = await deep.id(DEVICE_PACKAGE_NAME, "Name");
        //   const modelTypeLinkId = await deep.id(DEVICE_PACKAGE_NAME, "Model");
        //   const {data: deviceTreeLinksUpToParentDevice} = await deep.select({
        //     up: {
        //       tree_id: {
        //         _id: [DEVICE_PACKAGE_NAME, "DeviceTree"]
        //       },
        //       parent_id: {_eq: deviceLinkId}
        //     }
        //   });
        //   const nameLink = deviceTreeLinksUpToParentDevice.find(link => link.type_id === nameTypeLinkId);
        //   if(!nameLink) {
        //     throw new Error(`A link with type ##${nameTypeLinkId} associated with ##${deviceLinkId} is not found`);
        //   }
        //   if(!nameLink.value?.value) {
        //     throw new Error(`${nameLink.id} must have a value`)
        //   }
        //   const name = nameLink.value.value;
        //   const modelLink = deviceTreeLinksUpToParentDevice.find(link => link.type_id === modelTypeLinkId);
        //   if(!modelLink) {
        //     throw new Error(`A link with type ##${modelTypeLinkId} associated with ##${deviceLinkId} is not found`);
        //   }
        //   if(!modelLink.value?.value) {
        //     throw new Error(`${modelLink.id} must have a value`)
        //   }
        //   const model = modelLink.value.value;
        //   return {
        //     name,
        //     model
        //   }
        const { data: [deviceLink] } = yield deep.select(deviceLinkId);
        if (!deviceLink) {
            throw new Error(`A link with id ##${deviceLinkId} is not found`);
        }
        return deviceLink.value.value;
    });
}
